default:
  image: 'node:current-alpine3.18'

build-job:
  stage: build
  script:
    - npm i pnpm --location=global
    - pnpm i
    - pnpm run build
  artifacts:
    expire_in: 5 minutes
    name: "build-${CI_PROJECT_NAME}-${CI_COMMIT_SHA}"
    paths:
      - node_modules
      - dist

deploy-job:
  stage: deploy
  dependencies:
    - build-job
  before_script:
    - npm install wrangler --location=global
  script:
    - |
      if npx wrangler pages project list | grep -qw "${CI_PROJECT_NAME}"; then 
        echo "Page '${CI_PROJECT_NAME}' already created."; 
      else
        npx wrangler pages project create ${CI_PROJECT_NAME} --production-branch master;
      fi;
    
    - wrangler pages deploy ./dist --project-name ${CI_PROJECT_NAME} --branch ${CI_COMMIT_BRANCH}
  only:
    refs:
      - main
      - staging